<template>
  <!--
  <header>
    <img alt="Vue logo" class="logo" src="./assets/logo.svg" width="125" height="125" />

    <div class="wrapper">
      <HelloWorld msg="You did it!" />
    </div>
  </header>
  -->

  <main style="height: 100%;">
    <!--<TheWelcome />-->
    <div class="main_div">
      <div id="menu_collapse" v-show="expandBar" class="menu_collapse" @mouseover="expand(true)"
        @mouseout="expand(false)">
        <p>Catalejo</p>
        <div id="tree_and_commands" v-show="expandBar" class="tree_and_commands">
          <div>
            <MenubarCommon :plugins="plugins" :lang="lang" :workDirPath="workDirPath"
              :filePathSelected="filePathSelected" @dirconfig-update="dirconfigUpdate"
              @save-project-request="saveProjectRequest" @new-project-request="newProjectRequest"
              @dir-path-selected="dirPathSelected"
              @run-app-function-with-dialog-request="runAppFunctioWithDialogRequest" />
          </div>
          <!--
          <div id="selectworkdir">
            <FileUpload/>
          </div>
          -->
          <div id="treeview" class="treeview">
            <TreeView :filePaths="filePaths" :dirPaths="dirPaths" :dirPathsLength="dirPathsLength" :lang="lang"
              @file-selected="setFilePathSelected" @dir-path-selected="dirPathSelected" />
          </div>
        </div>
      </div>
      <div id="editor" class="editor">
        <div id="toolbar" class="toolbar">
          <ToolBar :lang="lang" :plugin="plugin" @menu-toggle="menuToggle" @save-project-request="saveProjectRequest"
            @close-project="closeProject" @config-project="configProject" @plugin-command="pluginCommand" />
        </div>
        <div id="tabView" class="tabview">
          <TabViewEditor :index="indexProject" :projects="projects" :contentchanges="contentChanges" :lang="lang"
            :update="requestUpdate" @index-of-project-to-load="indexOfProjectToLoad" />
        </div>
        <div id="blocklyEditor" class="blocklyeditorclass" v-show="workspaceSelected == WORKSPACE.BLOCKLY">
          <!-- TODO: el emit blockly debe ser quitado y refactorizar el montaje del workspace-->
          <BlocklyEditor :projects="projects" :index="indexProject" :workspace="workspaceSelected" :plugin="plugin"
            :update="requestUpdate" @xmltext-index="getUpdatesFromBlockly" @blockly-mounted="blocklyMounted" />
        </div>
        <div id="textEditor" class="texteditorclass" v-show="workspaceSelected == WORKSPACE.CODEMIRROR">
          <TextEditor :projects="projects" :index="indexProject" :workspace="workspaceSelected" :update="requestUpdate"
            @content-cursor-index="getUpdatesFromCodemirror" />
        </div>
        <!--
          -->
        <!--
          -->
      </div>
      <Dialog v-model:visible="visibleConfigProjectDialog" modal :header="titleConfigProjectDialog"
        :style="{ width: '32rem' }">
        <div>
          <div v-for="item in itemsConfigProjectDialog">
            <InputText type="text" size="small" v-model="item.label" class="textInputDialogClass" /><span>:&nbsp;</span>
            <InputText type="text" size="small" v-model="item.value" />
          </div>
          <Button type="button" :label="labelButtonClose" severity="secondary"
            @click="visibleConfigProjectDialog = false"></Button>
          <Button type="button" :label="labelButtonOk" @click="setConfigProjectDialog"></Button>
        </div>
      </Dialog>
      <Toast position="bottom-left" group="bl" />
      <!-- Dialogo sin uso
      <Dialog v-model:visible="visiblePluginDialog" modal :header="titlePluginDialog">
        <Textarea autoResize rows="30" cols="80">
          {{ contentDialog }}
        </Textarea>
        <div>
          <Button type="button" :label="labelButtonClose" severity="secondary"
            @click="visiblePluginDialog = false"></Button>
        </div>
      </Dialog>
      -->
      <DynamicDialog />
    </div>
    <div id="log">
    </div>
  </main>
</template>

<script setup lang="ts">
// Vue
import { ref, onMounted, watch } from "vue";
// Adds components
import Toast, { type ToastMessageOptions } from 'primevue/toast';
import TextEditor from '@/components/TextEditor.vue';
import TreeView from '@/components/TreeView.vue';
import TabViewEditor from "@/components/TabViewEditor.vue";
import MenubarCommon from "@/components/MenubarCommon.vue";
import BlocklyEditor from '@/components/BlocklyEditor.vue';
import ToolBar from '@/components/ToolBar.vue';
import Dialog from 'primevue/dialog';
import InputText from 'primevue/inputtext';
import Button from 'primevue/button';

//-- START DYNAMIC DIALOGS --
import DynamicDialog from 'primevue/dynamicdialog';
import TextprintDialog from "@/components/dialogs/TextprintDialog.vue";
import TextareaDialog from "@/components/dialogs/TextareaDialog.vue";
import UrlprintDialog from "@/components/dialogs/UrlprintDialog.vue";
import TerminalDialog from "@/components/dialogs/TerminalDialog.vue";
import YesNoQuestionDialog from "@/components/dialogs/YesNoQuestionDialog.vue";
import FileUploadDialog from "@/components/dialogs/FileUploadDialog.vue";
//-- END DYNAMIC DIALOGS --

// -- ADDS JS/TS COMPONENTS ---
import { useToast } from 'primevue/usetoast';
import { useDialog } from 'primevue/usedialog';
import * as app from '@/core/app';
import type { Project, Result, Plugin, PluginDictionary, PluginResult, DialogRequest } from '@/core/types';
import { STATUS, WORKSPACE, TYPE_PLUGIN_RESULT, TYPE_DIALOG_REQUEST } from '@/core/consts';
import { appLang, getTextFromLang } from "@/core/lang";
import { plugins as pluginsArray, defaultPaths } from '../plugins/plugins.js';
import { LANG } from '@/core/consts';
import { stringSearch } from '@/core/general';

// -- VARS FOR PROPS --
/** Archivos existentes en un directorio y que son cargables en el editor a través del treeview */
const filePaths = ref<string[]>([]);
/** Path del archivo seleccionado */
const filePathSelected = ref<string>("");
/** Paths de los diferentes directorios del editor, (se puede cargar en el treeview) */
const dirPaths = ref<string[]>([]);
/** Ruta del directorio de trabajo cargado en el workspace */
const workDirPath = ref<string>("");
/** Representación del tamaño del dirPaths que se usa para indicar que se ha anexado otro dir */
const dirPathsLength = ref<number>(0);
/** Projectos cargados en el editor */
const projects = ref<Project[]>([]);
/** Proyecto seleccionado para cargar en el workspace **/
const project = ref<Project>();
/** Indice del proyecto que está cargado en el workspace */
const indexProject = ref<number>();
/** Solicitud de actualizar algunas partes del código (se usa para solicitud de cambios manuales) */
const requestUpdate = ref<boolean>(false);
/** Detectar si existen cambios en el workspace por el usuario (cambios en Blockly o Codemirror)*/
const contentChanges = ref(false);
/** Lenguaje de la aplicación */
const lang = ref<LANG>(LANG.EN);
/** Workspace que será visualizado en la aplicación */
const workspaceSelected = ref<WORKSPACE>(WORKSPACE.BLOCKLY);
/** Referencia a plugins */
const plugins = ref<PluginDictionary>({});
const plugin = ref<Plugin>();

// TODO: Se ha fijado el valor del idioma, pero esto debe ser una característica
// de configuración del editor para el usuario.
lang.value = LANG.ES;

// var for emits

// -- VARS FOR THIS COMPONENT --
const toast = useToast();
const dialog = useDialog();
const expandBar = ref(true);
const defaultGroupToast = "bl" //bottom-left, top-right, etc 
const defaultOptionsToast = { group: defaultGroupToast } // Ver <Toast /> en el html

// -- VARS FOR DIALOG COMPONENT
/** Visibilidad del dialogo de configuración */
const visibleConfigProjectDialog = ref(false);
/** Título del diálogo para configuiración de proyectos */
const titleConfigProjectDialog = ref("");
const itemsConfigProjectDialog = ref([{ label: "", value: "" }]);
//-- COMMUN DIALOG --
const labelButtonOk = ref("");
const labelButtonClose = ref("");

// -- START METHODS FOR EMITS SIGNALS --
// Obtener desde menubar los items a cargar en el treeview de archivos
const dirconfigUpdate = (data: string[]) => {
  filePaths.value = data;
};

const setFilePathSelected = (path: string) => {
  filePathSelected.value = path;
}

// Obtener desde el tabvieweditor indice de proyecto a cargar en el workspace
const indexOfProjectToLoad = (data: number) => {
  indexProject.value = data;
};
// Obtener cambios desde codemirror y actualizar projects
const getUpdatesFromCodemirror = (content: string, codemirrorCursor: number, index: number) => {
  contentChanges.value = !(contentChanges.value);
  app.updateProjectFromCodemirror(
    projects.value,
    content,
    codemirrorCursor,
    index
  );
}
// Obtener cambios desde blockly y actualizar projects
const getUpdatesFromBlockly = (xmltext: string, index: number) => {
  contentChanges.value = !(contentChanges.value);
  app.updateProjectFromBlockly(
    projects.value,
    xmltext,
    index
  );
}

/** Crear un nuevo proyecto */
const newProjectRequest = async (path: string, content: string) => {
  const res = await app.newProject(projects.value, path, content);
  if (res.status == STATUS.REQUEST_SELECT_FILE_IN_TABVIEW) {
    indexProject.value = res.data;
  }
}

/** Atender solicitud de guardar cambios del proyecto en el workspace */
const saveProjectRequest = async () => {
  const res = await app.saveProject(projects.value, indexProject.value || 0);
  if (res.status == STATUS.OK) {
    toast.add({
      severity: 'success',
      summary: getTextFromLang(appLang.savefile.ok, lang.value),
      detail: '',
      life: 3000,
      group: defaultGroupToast,
    });
  } else {
    toast.add({
      severity: 'error',
      summary: getTextFromLang(appLang.savefile.error, lang.value),
      detail: '', life: 3000,
      group: defaultGroupToast,
    });
  }
};

/** Cerrar el proyecto que esté abierto en el workspace */
const closeProject = () => {
  // Existen proyectos cargados?
  if (projects.value.length > 0) {
    // Remover el projecto con el uso del indice
    app.removeProject(projects.value, indexProject.value || 0);
    // Aún existen proyectos cargados?
    if (projects.value.length > 0 && indexProject.value != undefined) {
      // El indice actual puede estar contenido en el tamaño de projects?
      if (indexProject.value < projects.value.length) {
        // Se hace la actualización del workspace requerida
        requestUpdate.value = !requestUpdate.value;
      } else {
        // Se cambia el index con lo cual se activan los watchers.
        indexProject.value = indexProject.value - 1;
      }
    }
    else {
      // Se deja la página de bienvenida en vista de que no hay proyectos cargados
      workspaceSelected.value = WORKSPACE.WELCOME;
      // Como no hay proyectos se pone a -1 para obligar a actualizar el workspace
      indexProject.value = -1;
    }
  }
}

/** Borrar archivo seleccionado del sistema de ficheros */
const deleteFileRequest = async (filePath: string) => {
  const res: Result = await app.deleteFile(filePath);
  if (res.status == STATUS.OK) {
    const data: ToastMessageOptions = {
      severity: "success",
      summary: getTextFromLang(appLang.deleteFile.ok, lang.value),
      detail: filePath,
      life: 3000,
      group: defaultGroupToast,
    };
    toast.add(data);
  } else {
    const data: ToastMessageOptions = {
      severity: "error",
      summary: getTextFromLang(appLang.deleteFile.error, lang.value),
      detail: filePath,
      life: 3000,
      group: defaultGroupToast,
    };
    toast.add(data);
  }
}


/** Cuando se realiza la solicitud de configuración de un proyecto, se verifica que en el indice de proyectos
 * haya un proyecto cargado y si es así, en el dialogo se carga la configuración de ese proyecto, esta
 * configuración se pone en itemsConfigProjectDialog, además se visibiliza el dialogo. */
const configProject = () => {
  titleConfigProjectDialog.value = getTextFromLang(appLang.titleConfigProjectDialog, lang.value);
  labelButtonOk.value = getTextFromLang(appLang.dialogButton.ok, lang.value);
  labelButtonClose.value = getTextFromLang(appLang.dialogButton.close, lang.value);
  if (indexProject.value != undefined) {
    itemsConfigProjectDialog.value = app.getConfigProjectForDialog(projects.value[indexProject.value]);
  }
  // Antes de configurar, debe consultar la actual configuración del proyecto.
  visibleConfigProjectDialog.value = true;
}

/** Si el workspace blockly es montado, dejar una ventana de bienvenida */
// TODO: Este método deberá ser quitado 2024-05-15
const blocklyMounted = () => {
  workspaceSelected.value = WORKSPACE.WELCOME;
}

/** Al seleccionar un path, se debe verificar que sea un path de un directorio.
 * Si es así, debe agregar el path al dirPaths y cargar el contenido al filePaths */
const dirPathSelected = async (dirPath: string) => {
  const res: Result = await app.getDirContent(dirPath);
  if (res.status == STATUS.OK) {
    // Identificar que el dirPath no esté cargado en el arreglo de dirPaths
    if (stringSearch(dirPaths.value, dirPath).status == STATUS.NOTFOUND) {
      // Actualizar los directorios de trabajo
      dirPaths.value.push(dirPath);
    }
    // Actualizar los archivos de el directorio seleccionado
    filePaths.value = res.data;
    // Actualizar el nombre del dirpath del editor
    workDirPath.value = dirPath;
    // Actualizar el tamaño del dirPaths para ser captado por un watcher
    dirPathsLength.value = dirPaths.value.length;
    const data: ToastMessageOptions = {
      severity: "info",
      summary: getTextFromLang(appLang.toastUpdateContentDir, lang.value),
      detail: dirPath,
      life: 3000,
      group: defaultGroupToast,
    }
    toast.add(data);
  }
}

const uploadFileRequest = async (files: File[]) => {
  for (let index = 0; index < files.length; index++) {
    const file = files[index];
    const formData = new FormData();
    formData.append('file', file);
    // formData.append('path', "/home/johnny/");
    const res = await app.uploadFile(formData);
    let data: ToastMessageOptions;
    if (res.status == STATUS.OK) {
      data = {
        severity: "info",
        summary: "Update file",
        detail: "",
        life: 3000,
        group: defaultGroupToast,
      }
    } else {
      data = {
        severity: "warn",
        summary: "Dont update",
        detail: "",
        life: 3000,
        group: defaultGroupToast,
      }
    }
    toast.add(data);
  }
}

const visiblePluginDialog = ref(false);
const titlePluginDialog = ref("");
const contentDialog = ref();

/** Controlador de resultados de diálogos dinámicos (DynamicDialog) para resultados de diferentes plugins */
const pluginCommand = async (commandId: string) => {
  // Indicador de que una tarea solicitada se encuentra en proceso
  toast.add({
    severity: "info",
    summary: getTextFromLang(appLang.toastProccess, lang.value),
    detail: "",
    life: 1500,
    group: defaultGroupToast,
  });
  if (plugin.value != undefined) {
    // Ejecutar la tarea solicitada por el plugin de manera asíncrona y esperar el resultado.
    const pluginResult: PluginResult = await plugin.value.commandEmit(project.value, commandId, lang.value);
    switch (pluginResult.typeResult) {
      case TYPE_PLUGIN_RESULT.TOAST:
        toast.add({ ...pluginResult.data, ...defaultOptionsToast }); // Agregar las demás opciones
        break;
      case TYPE_PLUGIN_RESULT.TEXT_PRINT:
        dialog.open(TextareaDialog, {
          data: pluginResult.data,
          props: {
            maximizable: true,
            // style: { width: '100%' },
            header: pluginResult.data.title,
          }
        });
        break;
      case TYPE_PLUGIN_RESULT.URL_PRINT:
        dialog.open(UrlprintDialog, {
          data: pluginResult.data,
          props: {
            maximizable: true,
            header: pluginResult.data.title,
          }
        });
        break;
      case TYPE_PLUGIN_RESULT.TERM:
        dialog.open(TerminalDialog, {
          data: pluginResult.data,
          props: {
            maximizable: true,
          }
        }); break;
      default:
        break;
    }
  }
};

/** Filtro seleccionador de funciones a ejecutar; algunas funciones requieren
 * ser llamadas desde por ejemplo diálogos y en respuesta afirmativa, desde el
 * el diálogo se puede solicitar la acción de esa función.
 */
const runFuntion = (emit: string, args: any) => {
  switch (emit) {
    case "delete-file-request":
      if (args.filePath)
        deleteFileRequest(args.filePath)
      break;
    case "upload-file":
      if (args.files) {
        uploadFileRequest(args.files);
      }
      break;
    default:
      break;
  }
}

/** Controlador de dialogos dinámico de funciones genéricas del editor */
const runAppFunctioWithDialogRequest = async (dialogRequest: DialogRequest) => {
  /** Dialog component solicitado */
  switch (dialogRequest.typeDialog) {
    case TYPE_DIALOG_REQUEST.YES_OR_NO_QUESTION:
      dialog.open(YesNoQuestionDialog,
        {
          data: dialogRequest.data,
          props: {
            maximizable: true,
            header: dialogRequest.data.title,
          },
          onClose: (result) => {
            const data = (result) ? result.data : false;
            if (data == true) runFuntion(dialogRequest.data.emit, dialogRequest.data.args);
          },
        });
      break;
    case TYPE_DIALOG_REQUEST.UPLOADFILE:
      dialog.open(FileUploadDialog, {
        data: dialogRequest.data,
        props: {
          maximizable: true,
          header: dialogRequest.data.title,
        },
        onClose: (result) => {
          const data: File[] = (result) ? result.data : undefined;
          if (data) runFuntion(dialogRequest.data.emit, { files: data });
        }
      });
      break;
    default:
      break;
  }
}
// -- END METHODS FOR EMITS SIGNALS --

//-- METHODS --
const expand = (action: any) => {
  // expandBar.value = action
};
const menuToggle = () => {
  // Expandir o colapsar el menú
  expandBar.value = !expandBar.value;
  // Actualizar el workspace, en especial BlocklyDiv
  requestUpdate.value = !requestUpdate.value;
};

/** Actualizar configuración de un proyecto desde dialogo */
const setConfigProjectDialog = () => {
  visibleConfigProjectDialog.value = false;
  // Actualizando la configuración del proyecto
  if (indexProject.value != undefined) {
    projects.value[indexProject.value].config =
      app.setConfigProjectFromItemsDialog(itemsConfigProjectDialog.value)
  }
}

// Actualizar workspace
const updateWorkspace = () => {
  if (projects.value.length > 0 && indexProject.value !== undefined) {
    const res = app.setWorkspace(projects.value[indexProject.value])
    if (res.status == STATUS.SET_WS) {
      workspaceSelected.value = res.data;
    }
  }
};

/** Actualizar plugin referencia según proyecto **/
const updatePlugin = () => {
  if (projects.value.length > 0 && indexProject.value !== undefined) {
    const platform = projects.value[indexProject.value].config.platform;
    if (platform != undefined && platform != "") {
      plugin.value = plugins.value[platform];
    } else {
      plugin.value = undefined;
    }
  }
};

const updateProject = () => {
  if (indexProject.value != undefined) {
    project.value = projects.value[indexProject.value];
  }
}

//-- WATCHERS --
/** Verificar cambios en el indexProject */
watch(indexProject, () => {
  // Actualizar workspace
  updateWorkspace();
  updatePlugin();
  updateProject();
});

/** Desde el path de un proyecto validar el path y agregar a proyects
 * si se satisface, actualizar el indice de proyectos, esto actualizará
 * el workspace */
watch(filePathSelected, async (path: string) => {
  const res = await app.addProject(projects.value, path || "");
  if (res.status == STATUS.REQUEST_SELECT_FILE_IN_TABVIEW) {
    indexProject.value = res.data;
  }
});

//-- ONMOUNTED --
onMounted(async () => {
  // TODO: esta información debe provenir de un lugar seguro
  // Debe ser dada de manera local (Linux u otro sistema)
  // Montar un directorio de trabajo por default
  for (const defaultPath of defaultPaths) {
    dirPathSelected(defaultPath);
  }

  // Iniciar plugins
  app.addPlugins(plugins.value, pluginsArray);
})

</script>

<style scoped>
@import './style/app.css';
</style>
